__author__ = 'Angus Jack 24-Jan-2019'
__version__ = '0.1.2'

import os
import sys
import shutil
import fileinput
import configparser
from gooey import Gooey
from gooey import GooeyParser
from argparse import ArgumentParser


@Gooey(
    program_name='Find and replace',
    advanced=True,
    navinavigation='TABBED',
    show_success_modal=False
)
def mainq():
    global a_file
    global create_backup
    global find_str
    global replace_str
    desc = "Script to find and replace in text files"
    file_help_msg = "Name of the file you want to process:"
    gui_parser = GooeyParser(description=desc)
    gooey_options = {'show_border': True, 'columns': 1}
    a_group = gui_parser.add_argument_group('', '', gooey_options=gooey_options)

    a_group.add_argument('text_file', metavar='File Name', help=file_help_msg, action='store', widget='FileChooser')
    a_group.add_argument('find', help="String to find:")
    a_group.add_argument('replace', help="String to replace:")
    args = gui_parser.parse_args()

    a_file = args.text_file
    find_str = args.find
    replace_str = args.replace


if __name__ == '__main__':

    mainq()
    # a_file = r'D:\2018-023a\Kingdom\temp\horizon_exports\05_Ins_Inter_Channeling_tLAT.csv'
    # find_str = 'blah'
    # replace_str = 'Easting'

    print(a_file + '\n')
    print('Find string is: ' + '"' + find_str + '"')
    print('Replace string is: ' + '"' + replace_str + '"')

    find_str = find_str.strip()
    replace_str = replace_str.strip()
    current_dir = os.getcwd()

    shutil.copyfile(a_file, a_file + '.bak')

    with fileinput.FileInput(a_file, inplace=True) as f:
        for line in f:
            line = line.replace(find_str, replace_str).rstrip()
            print(line)

    print('\n' + 'The top of the file looks like this:' + '\n')
    with open(a_file, 'r') as f:
        for index in range(10):
            line = next(f)
            print(line.rstrip())

